"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveExpressionInMember = void 0;
var t = __importStar(require("@babel/types"));
var common_1 = require("../../common");
var function_args_1 = require("./function-args");
var identifier_1 = require("./identifier");
var resolveExpressionInMember = function (expression, meta, expressionName, memberExpression, traversers) {
    var result = (0, common_1.createResultPair)(expression, meta);
    if (t.isIdentifier(expression)) {
        result = (0, identifier_1.evaluateIdentifier)(expression, meta);
    }
    else if (t.isFunction(expression)) {
        // Function expressions are the declaration and not the function call
        // itself, the arguments are stored in the member expression
        var callExpression = t.callExpression(expression, (0, function_args_1.getFunctionArgs)(expressionName, memberExpression));
        result = traversers.callExpression(callExpression, meta);
    }
    else if (t.isCallExpression(expression)) {
        result = traversers.callExpression(expression, meta);
    }
    else if (t.isMemberExpression(expression)) {
        result = traversers.memberExpression(expression, meta);
    }
    // Recursively resolve expression until we extracted its value node or
    // have reach its origin declaration
    if (result.value !== expression) {
        return (0, exports.resolveExpressionInMember)(result.value, result.meta, expressionName, memberExpression, traversers);
    }
    return result;
};
exports.resolveExpressionInMember = resolveExpressionInMember;
//# sourceMappingURL=index.js.map