import { transformSync } from '@babel/core';

import babelPlugin from '../../index';

const transform = (code: TemplateStringsArray) => {
  return transformSync(code[0], {
    configFile: false,
    babelrc: false,
    plugins: [babelPlugin],
  })?.code;
};

describe('css', () => {
  it('should remove css node if assigned to a variable', () => {
    const actual = transform`
      import { css } from '@compiled/react';

      export const _1 = css\`color: red;\`;
    `;

    expect(actual).toMatchInlineSnapshot(`
      "/* File generated by @compiled/babel-plugin v0.0.0 */

      import * as React from 'react';
      import { ax, ix, CC, CS } from \\"@compiled/react/runtime\\";
      export const _1 = null;"
    `);
  });
});
